﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=StaticCode
Version=8.1
@EndOfDesignText@
'Static code module
Sub Process_Globals
	Private BANano As BANano  'ignore
	Public vm As BANanoVM
	Public db, dbhost, user, pass As String
End Sub

Sub Init
	'initialize the page
	vm.Initialize(Me, Main.appname)
	db = "testdb" 'database name
	BuildNavBar
	BuildNavDrawer
	AddPages
	AddContent
	vm.ux
End Sub

'build the navigation bar
Sub BuildNavBar
	'*copy code after this line
	'add a hamburger
	vm.NavBar.AddHamburger
	vm.NavBar.Hamburger.SetVisible(True)
	'add a logo
	vm.NavBar.Logo.SetBorderRadius("50%")
	vm.NavBar.Logo.SetBorderWidth("1px")
	vm.NavBar.Logo.SetBorderColor("black")
	vm.NavBar.Logo.SetBorderStyle("solid")
	vm.NavBar.Logo.SetSize("46px","46px")
	vm.NavBar.AddLogo("./assets/bx.png")
	vm.NavBar.Logo.Show
	vm.NavBar.AddTitle(Main.AppTitle,"")
	vm.NavBar.AddSubHeading1(" 1.00")
	vm.NavBar.AddSpacer
	vm.NavBar.SetFixed(True)
	vm.NavBar.SetVisible(True)
	
End Sub

'build the nav drawer
Sub BuildNavDrawer
	'*copy code after this line
	vm.Drawer.Setwidth("300")
	vm.Drawer.Setvisible(True)
	'this page should show on the drawer
'	Dim bo As BANanoObject = BANano.GetLocalStorage("settaggi")
'	Dim jsonpars As BANanoJSONParser
'	jsonpars.Initialize(BANano.ToString(bo))
'	Dim m As Map = jsonpars.NextObject
'	db = m.Get("dbname")
	vm.Drawer.AddIcon1($"page${db}"$, "mdi-database", "", db, "Database")

End Sub


Sub LoadTables
	Dim dbsql As BANanoMySQLE
	dbsql.Initialize(db, "", "", "")
	'dbsql.SetConnection(dbhost, user, pass)
	dbsql.SetConnection("localhost", "root", "")
	dbsql.GetTableNames
	dbsql.json = BANano.CallInlinePHPWait(dbsql.MethodName, dbsql.Build)
	dbsql.FromJSON
	If dbsql.OK = False Then 
		vm.showsnackbarerror($"Errore lettura tabelle!"${CRLF}${dbsql.error}"$)
	Else
		vm.ShowSnackBarSuccess("Tabelle lette correttamente!")
	End If
	Dim l As List
	l.Initialize
	If dbsql.result.Size > 0 Then
		For Each record As Map In dbsql.result
			l.add(record.Get("table_name"))
		Next
		AddTableNav(l)
	End If
	Log("mostra Table")
End Sub

Sub AddTableNav(l As List)
'	Log(l)
'	Dim cbo1 As VMSelect = vm.CreateComboBox("cbo1", Me)
'	cbo1.SetLabel("Seleziona archivio").SetOutlined(True)
'	cbo1.AddItems(l)
'	vm.Drawer.AddChild(cbo1.Combo)
'	vm.Drawer.Refresh
	vm.Drawer.AddDivider
	vm.Drawer.AddParentChild("","ai", "", "", "Seleziona Archivio","")
	For i = 0 To l.Size - 1
		vm.Drawer.AddParentChild("ai","", "", "", l.Get(i),"")
		'Log(l.Get(i))
	Next
	vm.Drawer.Refresh
End Sub

'EVENT


'add pages to the app
Sub AddPages
'	'*copy code after this line
End Sub

'add content to this page
Sub AddContent
	'*copy code here to add to thos page
End Sub

'*IMPORTANT when a drawer item is clicked
Sub draweritems_click(e As BANanoEvent)
	'get the id from the event
	Dim elID As String = vm.GetIDFromEvent(e)
	Select Case elID
		'copy code below this line
		Case $"page${db}"$
			LoadTables
			
	End Select
End Sub

'confirm dialog ok click
Sub confirm_ok(e As BANanoEvent)
	Dim sconfirm As String = vm.GetConfirm
	Select Case sconfirm
		'copy code below this line
		Case "delete"
		'........
	End Select
End Sub

'confirm dialog cancel click
Sub cancel_ok(e As BANanoEvent)

End Sub

'alert dialog ok clock
Sub alert_ok(e As BANanoEvent)

End Sub

'confirm dialog cancel click
Sub confirm_cancel(e As BANanoEvent)

End Sub
